﻿'''If you do need to create a new control, the simplest way is to create a class that derives from 
''' UserControl. Before you do so, consider that your control will not support templates and 
''' therefore will not support complex customization.
Public Class ImageButton
    Inherits System.Windows.Controls.UserControl

    Public Sub New()

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.

        '- initial values when inserted to the window
        Width = 120
        Height = 30
        HorizontalAlignment = HorizontalAlignment.Left
        VerticalAlignment = VerticalAlignment.Top
        Margin = New Thickness(70, 40, 0, 0)

    End Sub

    Public Shared ReadOnly ImgBtn_BackgroundProperty As DependencyProperty = DependencyProperty.Register("Background", GetType(Brush), GetType(ImageButton), New UIPropertyMetadata(Brushes.LightGray))

    Public Overloads Property Background As Brush
        Get
            Return CType(GetValue(ImgBtn_BackgroundProperty), Brush)
        End Get
        Set(ByVal value As Brush)
            SetValue(ImgBtn_BackgroundProperty, value)
        End Set
    End Property


    Public Shared ReadOnly ImageProperty As DependencyProperty = DependencyProperty.Register("Image", GetType(ImageSource), GetType(ImageButton), New UIPropertyMetadata)

    Public Property Image As ImageSource
        Get
            Return CType(GetValue(ImageProperty), ImageSource)
        End Get
        Set(ByVal value As ImageSource)
            SetValue(ImageProperty, value)
        End Set
    End Property


    Public Shared ReadOnly TextProperty As DependencyProperty = DependencyProperty.Register("Text", GetType(String), GetType(ImageButton), New UIPropertyMetadata("ImageButton"))

    Public Property Text As String

        Get
            Return CType(GetValue(TextProperty), String)
        End Get
        Set(ByVal value As String)
            SetValue(TextProperty, value)
        End Set

    End Property

    Public Shared ReadOnly ImgBtn_ForegroundProperty As DependencyProperty = DependencyProperty.Register("Foreground", GetType(Brush), GetType(ImageButton), New UIPropertyMetadata(Brushes.Black))

    Public Overloads Property Foreground As Brush
        Get
            Return CType(GetValue(ImgBtn_ForegroundProperty), Brush)
        End Get
        Set(ByVal value As Brush)
            SetValue(ImgBtn_ForegroundProperty, value)
        End Set
    End Property

    Public Event Click As RoutedEventHandler
    Private Sub Button_Click(sender As Object, e As RoutedEventArgs)
        RaiseEvent Click(Me, e)
    End Sub

End Class
